# Repeat the steps for 50 times.
	# Create 50 Luns and map them to tihe host.
	# Discover them on the host. Sleep for 10 Seconds.
	# Run multipath -ll and collect output
	# Remove the multipath devices using multipath -F
	# Wait for 15 Seconds.
	# Collect lsmod and multipathd -k"list paths" output.
	# Unmap luns from the controllers.
	# Remove the SCSI devices
	# Run multipath -ll and collect output

RSH=/usr/bin/rsh
flag_create_luns=0
flag_destroy_luns=0
map_unmap="map"
igroup="200-108"
FILERIP1=10.72.201.28
FILERIP2=10.72.201.29
start_lun=1
end_lun=25

create_luns () {
	echo "Creating Luns on the Filers..."
	for ((  i = $start_lun ;  i <= $end_lun;  i++  ))
	do
		$RSH -l root: $FILERIP1 "vol create vol_raj_$i aggr0 20m"
		$RSH -l root: $FILERIP1 "lun create -t linux -s 5m /vol/vol_raj_$i/raj_lun_$i";
		$RSH -l root: $FILERIP2 "vol create vol_raj2_$i aggr0 20m"
		$RSH -l root: $FILERIP2 "lun create -t linux -s 5m /vol/vol_raj2_$i/raj_2_lun_$i";
	done
}

map_luns () {
	echo "Mapping Luns on the Filers..."
	map_unmap="map"
	for ((  i = $start_lun ;  i <= $end_lun;  i++  ))
	do
		$RSH -l root: $FILERIP1 "lun $map_unmap /vol/vol_raj_$i/raj_lun_$i $igroup";
		$RSH -l root: $FILERIP2 "lun $map_unmap /vol/vol_raj2_$i/raj_2_lun_$i $igroup";
	done
}

discover_luns () {
	echo "Discovering Luns on the host..."
	/root/ql-dynamic-tgt-lun-disc-2.16/ql-dynamic-tgt-lun-disc.sh -s -r
	sleep 10;
}

collect_multipath_data () {
	echo "Collecting multipath related data..."
	echo "" >> multipath_ll_output
	echo "===== Iteration Number $iteration =====" >> multipath_ll_output
	echo "" >> multipath_ll_output
	multipath -ll >> multipath_ll_output
	no_good_paths=`multipath -ll | grep -c .active..ready.`
	echo "--- Total Number of GOOD paths = $no_good_paths" >> multipath_ll_output
	echo "" >> multipath_ll_output
}

destroy_luns () {
	for ((  i = $start_lun ;  i <= $end_lun;  i++  ))
	do
		rsh -l root: $FILERIP1 "vol offline /vol/vol_raj_$i";
		rsh -l root: $FILERIP1 "vol destroy /vol/vol_raj_$i -f";

		rsh -l root: $FILERIP2 "vol offline /vol/vol_raj2_$i";
		rsh -l root: $FILERIP2 "vol destroy /vol/vol_raj2_$i -f";
	done
}

unmap_luns () {
	echo "Unmapping Luns on the Filers..."
	map_unmap="unmap"
	for ((  i = $start_lun ;  i <= $end_lun;  i++  ))
	do
		$RSH -l root: $FILERIP1 "lun $map_unmap /vol/vol_raj_$i/raj_lun_$i $igroup";
		$RSH -l root: $FILERIP2 "lun $map_unmap /vol/vol_raj2_$i/raj_2_lun_$i $igroup";
	done
}

remove_SCSI_devices () {
	echo "Removing the SCSI devices on the host..."
	/root/ql-dynamic-tgt-lun-disc-2.16/ql-dynamic-tgt-lun-disc.sh -s -r
}

cleanup_dmmp_devices () {
	echo "Removing the dm-mp devices from the host..."
	multipath -F
}

collect_lsmod_data () {
	echo "Collecting the lsmod output..."
	lsmod | grep qla
}

collect_pathinfo_multipathd () {
	echo "Collecting the multipathd -k list paths information..."
	multipathd -k < list_paths
}

if [ $flag_create_luns == 1 ]; then
	create_luns
fi

for ((  iteration = 1 ;  iteration < 50;  iteration++  ))
do
	echo "Iteration Number: $iteration"

	date
	map_luns

	date
	discover_luns

	date
	collect_multipath_data

	date
	cleanup_dmmp_devices

	echo "Sleeping for 15 seconds..."
	sleep 15

	date
	collect_lsmod_data

	date
	collect_pathinfo_multipathd

	date
	unmap_luns

	date
	remove_SCSI_devices

	date
	collect_multipath_data
done

if [ $flag_destroy_luns == 1 ]; then
	destroy_luns
fi
